Summary: Generic SPARC linux kernel
Name: kernel-sparc
Version: 2.0.18
Release: 3
Copyright: GPL
ExclusiveArch: sparc
Group: Base/Kernel
Provides: module-info
Source: vger.rutgers.edu:/pub/Linux/snapshots/sparclinux-960905.tar.gz
Source1: kernel-config.sparc
Source2: module-info
Patch: kernel-make.patch
BuildRoot: /tmp/kernel

%package -n kernel-source
Summary: Kernel source tree
Group: Base/Kernel
Provides: kernel-source

%package -n kernel-modules
Requires: kernel-sparc = 2.0.18
Summary: Collection of kernel modules
Group: Base/Kernel
Provides: kernel-modules

%package -n kernel-headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel
Provides: kernel-headers

%description -n kernel-headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description -n kernel-source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description -n kernel-modules
This package includes the modules which provide the support for most
supported hardware devices.  The modules are loaded into the running
kernel after it is booted.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
zcat $RPM_SOURCE_DIR/sparclinux-960905.tar.gz | tar -xvf-
chown root.root -R linux

find linux -name "*.orig" -print | xargs rm -f
mv linux linux-2.0.18
ln -sf linux-2.0.18 linux

cd linux-2.0.18

%patch -p1 

cp $RPM_SOURCE_DIR/kernel-config.sparc arch/sparc/defconfig

%build
cd $RPM_BUILD_ROOT/usr/src/linux-2.0.18
make oldconfig
make symlinks
make include/linux/version.h

rm -f /usr/include/linux 
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/asm /usr/include/asm

make vmlinux
make modules

rm -f /usr/include/linux 
ln -sf ../src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf ../src/linux/include/asm /usr/include/asm

%install
cd $RPM_BUILD_ROOT/usr/src/linux-2.0.18
mkdir $RPM_BUILD_ROOT/boot
install -m 644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot
install -m 644 System.map $RPM_BUILD_ROOT/boot

strip vmlinux
gzip -9 vmlinux
cp vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinux-2.0.18.gz
ln -sf vmlinux-2.0.18.gz $RPM_BUILD_ROOT/boot/vmlinux.gz

make PREFIX=$RPM_BUILD_ROOT modules_install

cd $RPM_BUILD_ROOT/usr/src/linux-2.0.18

# keep kernel-source archive clean
make mrproper
make oldconfig
make symlinks
make include/linux/version.h

# make /usr/include/scsi link
mkdir -p ../../include
ln -s /usr/src/linux/include/scsi ../../include/scsi

%clean
rm -rf $RPM_BUILD_ROOT

%preun -n kernel-modules
if [ `uname -r` = "2.0.18" ]; then 
	echo "You cannot remove the kernel-modules package for the currently "
	echo "running kernel".
	exit 1
fi

%files
/boot/*

%files -n kernel-source
/usr/src/linux
%dir /usr/src/linux-2.0.18
/usr/src/linux-2.0.18/COPYING
/usr/src/linux-2.0.18/CREDITS
/usr/src/linux-2.0.18/Documentation
/usr/src/linux-2.0.18/MAINTAINERS
/usr/src/linux-2.0.18/Makefile
/usr/src/linux-2.0.18/Makefile.orig
/usr/src/linux-2.0.18/README
/usr/src/linux-2.0.18/Rules.make
/usr/src/linux-2.0.18/arch
/usr/src/linux-2.0.18/drivers
/usr/src/linux-2.0.18/fs
/usr/src/linux-2.0.18/init
/usr/src/linux-2.0.18/ipc
/usr/src/linux-2.0.18/kernel
/usr/src/linux-2.0.18/lib
/usr/src/linux-2.0.18/mm
/usr/src/linux-2.0.18/modules
/usr/src/linux-2.0.18/net
/usr/src/linux-2.0.18/scripts

%files -n kernel-headers
/usr/src/linux-2.0.18/include
/usr/include/scsi

%files -n kernel-modules
%dir /lib/modules
%dir /lib/modules/2.0.18
/lib/modules/2.0.18/net
/lib/modules/2.0.18/block
/lib/modules/2.0.18/fs
/lib/modules/2.0.18/misc
/lib/modules/2.0.18/ipv4

